diff --git a/src/main/java/net/minecraft/core/block/FlagBlock.java b/src/main/java/net/minecraft/core/block/BlockFlag.java
similarity index 79%
rename from src/main/java/net/minecraft/core/block/FlagBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFlag.java
index 4e1fc375d..92c2be5e1 100644
--- a/src/main/java/net/minecraft/core/block/FlagBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFlag.java
@@ -1,7 +1,7 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.FlagBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityFlag;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
@@ -14,9 +14,9 @@ import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
-public class FlagBlock extends EntityBlock {
+public class BlockFlag extends BlockTileEntity {
 
-    public FlagBlock(String key, String namespaceId, int id, Material material) {
+    public BlockFlag(String key, String namespaceId, int id, Material material) {
         super(key, namespaceId, id, material);
         float f = 2 / 16f;
         float f1 = 1.0F;
@@ -41,13 +41,13 @@ public class FlagBlock extends EntityBlock {
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         ItemStack stack = new ItemStack(Items.FLAG);
-        if (blockEntity != null)
+        if (tileEntity != null)
         {
             CompoundTag compound = new CompoundTag();
-            ((FlagBlockEntity) blockEntity).writeFlagNBT(compound);
+            ((TileEntityFlag) tileEntity).writeFlagNBT(compound);
             stack.getData().putCompound("FlagData", compound);
         }
         return new ItemStack[] { stack };
@@ -56,7 +56,7 @@ public class FlagBlock extends EntityBlock {
 	@Override
 	public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
 		if (!world.isClientSide) {
-			FlagBlockEntity flag = (FlagBlockEntity) world.getBlockEntity(x, y, z);
+			TileEntityFlag flag = (TileEntityFlag) world.getBlockEntity(x, y, z);
 			if (flag.owner != null && !player.uuid.equals(flag.owner)) {
 				return false;
 			}
@@ -76,10 +76,10 @@ public class FlagBlock extends EntityBlock {
     }
 
     @Override
-    protected BlockEntity getNewBlockEntity() {
+    protected TileEntity getNewBlockEntity() {
         try
         {
-            return new FlagBlockEntity();
+            return new TileEntityFlag();
         }
         catch(Exception exception)
         {
diff --git a/src/main/java/net/minecraft/core/block/FlowerBlock.java b/src/main/java/net/minecraft/core/block/BlockFlower.java
similarity index 95%
rename from src/main/java/net/minecraft/core/block/FlowerBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFlower.java
index a5a25e320..cf3a4f045 100644
--- a/src/main/java/net/minecraft/core/block/FlowerBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFlower.java
@@ -15,25 +15,25 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class FlowerBlock extends Block implements IBonemealable {
+public class BlockFlower extends Block implements IBonemealable {
     public static final int MASK_PERMANENT = 0b1000_0000;
 
     public boolean killedByWeather = false;
     public boolean canBeBonemealed = false;
 
-    public FlowerBlock(String key, String namespaceId, int id) {
+    public BlockFlower(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.plant);
         setTicking(true);
         float f = 0.2F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f * 3F, 0.5F + f);
     }
 
-    public FlowerBlock setKilledByWeather() {
+    public BlockFlower setKilledByWeather() {
         killedByWeather = true;
         return this;
     }
 
-    public FlowerBlock setBonemealable() {
+    public BlockFlower setBonemealable() {
         canBeBonemealed = true;
         return this;
     }
diff --git a/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java b/src/main/java/net/minecraft/core/block/BlockFlowerStackable.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/StackedFlowerBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFlowerStackable.java
index fb726d84b..a5f24c6f8 100644
--- a/src/main/java/net/minecraft/core/block/StackedFlowerBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFlowerStackable.java
@@ -1,70 +1,70 @@
-package net.minecraft.core.block;
-
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.enums.EnumBlockSoundEffectType;
-import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.World;
-import org.jetbrains.annotations.Nullable;
-
-/**
- * Represents a flower block that can store multiple flowers within itself, up to a maximum of 4.
- */
-public class StackedFlowerBlock extends FlowerBlock {
-    public static final int MASK_STACK_COUNT = 0b0110_0000;
-    public static final int OFFSET_STACK_COUNT = 5;
-    public static final int MAX_STACK_COUNT = MASK_STACK_COUNT >> OFFSET_STACK_COUNT;
-
-    public StackedFlowerBlock(String key, String namespaceId, int id) {
-        super(key, namespaceId, id);
-    }
-
-    @Override
-    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
-        final int metadata = stack.getMetadata();
-        return setPermanent(metadata, true);
-    }
-
-    @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity) {
-        final int stackCount = getStackCount(meta) + 1;
-
-        if (dropCause == EnumDropCause.PICK_BLOCK) {
-            return new ItemStack[] { new ItemStack(this, 1, 0) };
-        } else if (dropCause == EnumDropCause.SILK_TOUCH) {
-            return new ItemStack[] { new ItemStack(this, 1, meta & MASK_STACK_COUNT)};
-        } else {
-            return new ItemStack[] { new ItemStack(this, stackCount, 0) };
-        }
-    }
-
-    @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
-        final int metadata = world.getBlockMetadata(x, y, z);
-        final int currentStackCount = getStackCount(metadata);
-        if (currentStackCount >= MAX_STACK_COUNT) {
-            return false;
-        }
-
-        final ItemStack heldItem = player.getHeldItem();
-        if (heldItem == null || heldItem.stackSize < 1 || heldItem.getItem().id != this.id) {
-            return false;
-        }
-
-        final int newMetadata = setPermanent(setStackCount(metadata, currentStackCount + 1), true);
-        world.setBlockMetadataWithNotify(x, y, z, newMetadata);
-        world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
-        heldItem.consumeItem(player);
-        return true;
-    }
-
-    public static int getStackCount(int metadata) {
-        return (metadata & MASK_STACK_COUNT) >> OFFSET_STACK_COUNT;
-    }
-
-    public static int setStackCount(int metadata, int stackCount) {
-        return (metadata & ~MASK_STACK_COUNT) | ((stackCount << OFFSET_STACK_COUNT) & MASK_STACK_COUNT);
-    }
-}
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.enums.EnumBlockSoundEffectType;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+/**
+ * Represents a flower block that can store multiple flowers within itself, up to a maximum of 4.
+ */
+public class BlockFlowerStackable extends BlockFlower {
+    public static final int MASK_STACK_COUNT = 0b0110_0000;
+    public static final int OFFSET_STACK_COUNT = 5;
+    public static final int MAX_STACK_COUNT = MASK_STACK_COUNT >> OFFSET_STACK_COUNT;
+
+    public BlockFlowerStackable(String key, String namespaceId, int id) {
+        super(key, namespaceId, id);
+    }
+
+    @Override
+    public int getPlacedBlockMetadata(@Nullable Player player, ItemStack stack, World world, int x, int y, int z, Side side, double xPlaced, double yPlaced) {
+        final int metadata = stack.getMetadata();
+        return setPermanent(metadata, true);
+    }
+
+    @Override
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
+        final int stackCount = getStackCount(meta) + 1;
+
+        if (dropCause == EnumDropCause.PICK_BLOCK) {
+            return new ItemStack[] { new ItemStack(this, 1, 0) };
+        } else if (dropCause == EnumDropCause.SILK_TOUCH) {
+            return new ItemStack[] { new ItemStack(this, 1, meta & MASK_STACK_COUNT)};
+        } else {
+            return new ItemStack[] { new ItemStack(this, stackCount, 0) };
+        }
+    }
+
+    @Override
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+        final int metadata = world.getBlockMetadata(x, y, z);
+        final int currentStackCount = getStackCount(metadata);
+        if (currentStackCount >= MAX_STACK_COUNT) {
+            return false;
+        }
+
+        final ItemStack heldItem = player.getHeldItem();
+        if (heldItem == null || heldItem.stackSize < 1 || heldItem.getItem().id != this.id) {
+            return false;
+        }
+
+        final int newMetadata = setPermanent(setStackCount(metadata, currentStackCount + 1), true);
+        world.setBlockMetadataWithNotify(x, y, z, newMetadata);
+        world.playBlockSoundEffect(player, x + 0.5f, y + 0.5f, z + 0.5f, this, EnumBlockSoundEffectType.PLACE);
+        heldItem.consumeItem(player);
+        return true;
+    }
+
+    public static int getStackCount(int metadata) {
+        return (metadata & MASK_STACK_COUNT) >> OFFSET_STACK_COUNT;
+    }
+
+    public static int setStackCount(int metadata, int stackCount) {
+        return (metadata & ~MASK_STACK_COUNT) | ((stackCount << OFFSET_STACK_COUNT) & MASK_STACK_COUNT);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/FluidBlock.java b/src/main/java/net/minecraft/core/block/BlockFluid.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/FluidBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFluid.java
index e9a7cf6bf..22be11beb 100644
--- a/src/main/java/net/minecraft/core/block/FluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFluid.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
@@ -15,10 +15,10 @@ import net.minecraft.core.world.WorldSource;
 
 import java.util.Random;
 
-public abstract class FluidBlock extends Block
+public abstract class BlockFluid extends Block
 {
 
-	public FluidBlock(String key, String namespaceId, int id, Material material)
+	public BlockFluid(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
@@ -222,11 +222,11 @@ public abstract class FluidBlock extends Block
         Vec3 vec3 = null;
         if(material == Material.water)
         {
-            vec3 = ((FluidBlock)Blocks.FLUID_WATER_FLOWING).getFlow(blockAccess, x, y, z);
+            vec3 = ((BlockFluid)Blocks.FLUID_WATER_FLOWING).getFlow(blockAccess, x, y, z);
         }
         if(material == Material.lava)
         {
-            vec3 = ((FluidBlock)Blocks.FLUID_LAVA_FLOWING).getFlow(blockAccess, x, y, z);
+            vec3 = ((BlockFluid)Blocks.FLUID_LAVA_FLOWING).getFlow(blockAccess, x, y, z);
         }
         if(vec3 == null ||(vec3.x == 0.0D && vec3.z == 0.0D))
         {
@@ -307,7 +307,7 @@ public abstract class FluidBlock extends Block
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         return null;
     }
@@ -323,10 +323,10 @@ public abstract class FluidBlock extends Block
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        float f7 = FluidBlock.getFluidHeight(world, x, y, z, blockMaterial);
-        float f8 = FluidBlock.getFluidHeight(world, x, y, z + 1, blockMaterial);
-        float f9 = FluidBlock.getFluidHeight(world, x + 1, y, z + 1, blockMaterial);
-        float f10 = FluidBlock.getFluidHeight(world, x + 1, y, z, blockMaterial);
+        float f7 = BlockFluid.getFluidHeight(world, x, y, z, blockMaterial);
+        float f8 = BlockFluid.getFluidHeight(world, x, y, z + 1, blockMaterial);
+        float f9 = BlockFluid.getFluidHeight(world, x + 1, y, z + 1, blockMaterial);
+        float f10 = BlockFluid.getFluidHeight(world, x + 1, y, z, blockMaterial);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, Math.max((f7 + f8 + f9 + f10)/4f, 0.2), 1.0F);
     }
 
@@ -348,10 +348,10 @@ public abstract class FluidBlock extends Block
                 int i2 = worldSource.getBlockMetadata(j1, y, l1);
                 if(i2 >= 8 || i2 == 0)
                 {
-                    f += FluidBlock.getWaterVolume(i2) * 10F;
+                    f += BlockFluid.getWaterVolume(i2) * 10F;
                     l += 10;
                 }
-                f += FluidBlock.getWaterVolume(i2);
+                f += BlockFluid.getWaterVolume(i2);
                 l++;
                 continue;
             }
diff --git a/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java b/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
similarity index 97%
rename from src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
index 0a720d358..fae1bca73 100644
--- a/src/main/java/net/minecraft/core/block/FlowingFluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFluidFlowing.java
@@ -9,17 +9,17 @@ import net.minecraft.core.world.World;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            FluidBlock, World, Material, WorldProvider,
+//            BlockFluid, World, Material, WorldProvider,
 //            Block
 
-public class FlowingFluidBlock extends FluidBlock
+public class BlockFluidFlowing extends BlockFluid
 {
     int maxCount;
     boolean[] result;
     int[] distance;
 
 
-	public FlowingFluidBlock(String key, String namespaceId, int id, Material material)
+	public BlockFluidFlowing(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         maxCount = 0;
@@ -273,7 +273,7 @@ public class FlowingFluidBlock extends FluidBlock
     private boolean isFluidBlocking(World world, int x, int y, int z)
     {
         int id = world.getBlockId(x, y, z);
-        if (Block.blocksList[id] == null || Block.blocksList[id] instanceof FluidBlock || Block.blocksList[id].hasTag(BlockTags.BROKEN_BY_FLUIDS)) return false;
+        if (Block.blocksList[id] == null || Block.blocksList[id] instanceof BlockFluid || Block.blocksList[id].hasTag(BlockTags.BROKEN_BY_FLUIDS)) return false;
         return true;
     }
 
diff --git a/src/main/java/net/minecraft/core/block/StillFluidBlock.java b/src/main/java/net/minecraft/core/block/BlockFluidStill.java
similarity index 93%
rename from src/main/java/net/minecraft/core/block/StillFluidBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFluidStill.java
index 5e9e11587..7a5f4bdd4 100644
--- a/src/main/java/net/minecraft/core/block/StillFluidBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFluidStill.java
@@ -5,10 +5,10 @@ import java.util.Random;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-public class StillFluidBlock extends FluidBlock
+public class BlockFluidStill extends BlockFluid
 {
 
-	public StillFluidBlock(String key, String namespaceId, int id, Material material)
+	public BlockFluidStill(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
         setTicking(false);
@@ -71,6 +71,6 @@ public class StillFluidBlock extends FluidBlock
 
     private boolean isFlammable(World world, int x, int y, int z)
     {
-        return FireBlock.canBurn(world, x, y, z);
+        return BlockFire.canBurn(world, x, y, z);
     }
 }
diff --git a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java b/src/main/java/net/minecraft/core/block/BlockFullyRotatable.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/FullRotatableBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFullyRotatable.java
index cd1a70b42..16a5ec55e 100644
--- a/src/main/java/net/minecraft/core/block/FullRotatableBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFullyRotatable.java
@@ -1,36 +1,35 @@
-package net.minecraft.core.block;
-
-import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Mob;
-import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.World;
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
-import org.jetbrains.annotations.NotNull;
-
-public abstract class FullRotatableBlock extends Block {
-    public static final int MASK_DIRECTION = 0b0000_0111;
-    public FullRotatableBlock(String translationKey, String namespaceId, int id, Material material) {
-        super(translationKey, namespaceId, id, material);
-    }
-
-    @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
-        final Direction direction = mob.getPlacementDirection(side).getOpposite();
-
-        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
-    }
-
-    @Override
-    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
-        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(side.getDirection()));
-    }
-
-    public static int directionToMeta(Direction direction) {
-        return direction.getId() & MASK_DIRECTION;
-    }
-
-    public static Direction metaToDirection(int meta) {
-        return Direction.getDirectionById(meta & MASK_DIRECTION);
-    }
-}
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+public abstract class BlockFullyRotatable extends Block {
+    public static final int MASK_DIRECTION = 0b0000_0111;
+    public BlockFullyRotatable(String translationKey, String namespaceId, int id, Material material) {
+        super(translationKey, namespaceId, id, material);
+    }
+
+    @Override
+    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double xPlaced, double yPlaced) {
+        final Direction direction = mob.getPlacementDirection(side).getOpposite();
+
+        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(direction));
+    }
+
+    @Override
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        world.setBlockMetadataWithNotify(x, y, z, directionToMeta(side.getDirection()));
+    }
+
+    public static int directionToMeta(Direction direction) {
+        return direction.getId() & MASK_DIRECTION;
+    }
+
+    public static Direction metaToDirection(int meta) {
+        return Direction.getDirectionById(meta & MASK_DIRECTION);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/FurnaceBlock.java b/src/main/java/net/minecraft/core/block/BlockFurnace.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/FurnaceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFurnace.java
index 8928ba6da..9c380a1cd 100644
--- a/src/main/java/net/minecraft/core/block/FurnaceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFurnace.java
@@ -2,10 +2,9 @@ package net.minecraft.core.block;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.FurnaceBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityFurnace;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -18,21 +17,21 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, Block, World, 
-//            IBlockAccess, FurnaceBlockEntity, Player, BlockEntity,
+//            IBlockAccess, TileEntityFurnace, Player, TileEntity,
 //            Mob, MathHelper, IInventory, ItemStack,
-//            ItemEntity
+//            EntityItem
 
-public class FurnaceBlock extends RotatableEntityBlock
+public class BlockFurnace extends BlockTileEntityRotatable
 {
     private static final Logger LOGGER = LogUtils.getLogger();
-	public FurnaceBlock(String key, String namespaceId, int id, boolean flag)
+	public BlockFurnace(String key, String namespaceId, int id, boolean flag)
     {
         super(key, namespaceId, id, Material.stone);
         isActive = flag;
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
@@ -86,7 +85,7 @@ public class FurnaceBlock extends RotatableEntityBlock
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            FurnaceBlockEntity tileentityfurnace = (FurnaceBlockEntity) world.getBlockEntity(x, y, z);
+            TileEntityFurnace tileentityfurnace = (TileEntityFurnace) world.getBlockEntity(x, y, z);
             player.displayFurnaceScreen(tileentityfurnace);
         }
         return true;
@@ -94,8 +93,8 @@ public class FurnaceBlock extends RotatableEntityBlock
 
 	public static void updateFurnaceBlockState(boolean lit, @NotNull World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		BlockEntity blockEntity = world.getBlockEntity(x, y, z);
-		if(blockEntity == null) {
+		TileEntity tileEntity = world.getBlockEntity(x, y, z);
+		if(tileEntity == null) {
 			String msg = "Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
 				throw new RuntimeException(msg);
@@ -112,14 +111,14 @@ public class FurnaceBlock extends RotatableEntityBlock
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
-		blockEntity.validate();
-		world.setBlockTileEntity(x, y, z, blockEntity);
+		tileEntity.validate();
+		world.setBlockTileEntity(x, y, z, tileEntity);
 	}
 
     @Override
-	protected BlockEntity getNewBlockEntity()
+	protected TileEntity getNewBlockEntity()
     {
-        return new FurnaceBlockEntity();
+        return new TileEntityFurnace();
     }
 
     protected Random furnaceRand;
diff --git a/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java b/src/main/java/net/minecraft/core/block/BlockFurnaceBlast.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
rename to src/main/java/net/minecraft/core/block/BlockFurnaceBlast.java
index 573109ede..d34d941a3 100644
--- a/src/main/java/net/minecraft/core/block/BlastFurnaceBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockFurnaceBlast.java
@@ -2,8 +2,8 @@ package net.minecraft.core.block;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityFurnaceBlastFurnace;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -15,21 +15,21 @@ import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
 //            BlockContainer, Material, Block, World,
-//            IBlockAccess, FurnaceBlockEntity, Player, BlockEntity,
+//            IBlockAccess, TileEntityFurnace, Player, TileEntity,
 //            Mob, MathHelper, IInventory, ItemStack,
-//            ItemEntity
+//            EntityItem
 
-public class BlastFurnaceBlock extends FurnaceBlock
+public class BlockFurnaceBlast extends BlockFurnace
 {
     private static final Logger LOGGER = LogUtils.getLogger();
 
-	public BlastFurnaceBlock(String key, String namespaceId, int id, boolean flag)
+	public BlockFurnaceBlast(String key, String namespaceId, int id, boolean flag)
     {
         super(key, namespaceId, id, flag);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
@@ -47,7 +47,7 @@ public class BlastFurnaceBlock extends FurnaceBlock
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            BlastFurnaceBlockEntity tileentityblastfurnace = (BlastFurnaceBlockEntity) world.getBlockEntity(x, y, z);
+            TileEntityFurnaceBlastFurnace tileentityblastfurnace = (TileEntityFurnaceBlastFurnace) world.getBlockEntity(x, y, z);
             player.displayFurnaceScreen(tileentityblastfurnace);
         }
         return true;
@@ -90,8 +90,8 @@ public class BlastFurnaceBlock extends FurnaceBlock
 
 	public static void updateFurnaceBlockState(boolean lit, World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
-		BlockEntity blockEntity = world.getBlockEntity(x, y, z);
-		if(blockEntity == null) {
+		TileEntity tileEntity = world.getBlockEntity(x, y, z);
+		if(tileEntity == null) {
 			String msg = "Blast Furnace is missing Tile Entity at x: "+x+" y: "+y+" z: "+z+", block will be removed!";
 			if(Global.BUILD_CHANNEL.isUnstableBuild()) {
 				throw new RuntimeException(msg);
@@ -108,14 +108,14 @@ public class BlastFurnaceBlock extends FurnaceBlock
 		}
 		keepFurnaceInventory = false;
 		world.setBlockMetadataWithNotify(x, y, z, meta);
-		blockEntity.validate();
-		world.setBlockTileEntity(x, y, z, blockEntity);
+		tileEntity.validate();
+		world.setBlockTileEntity(x, y, z, tileEntity);
 	}
 
     @Override
-	protected BlockEntity getNewBlockEntity()
+	protected TileEntity getNewBlockEntity()
     {
-        return new BlastFurnaceBlockEntity();
+        return new TileEntityFurnaceBlastFurnace();
     }
 
 }
diff --git a/src/main/java/net/minecraft/core/block/GlassBlock.java b/src/main/java/net/minecraft/core/block/BlockGlass.java
similarity index 76%
rename from src/main/java/net/minecraft/core/block/GlassBlock.java
rename to src/main/java/net/minecraft/core/block/BlockGlass.java
index 75b62585c..636ba6b05 100644
--- a/src/main/java/net/minecraft/core/block/GlassBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockGlass.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -9,16 +9,16 @@ import net.minecraft.core.world.World;
 // Referenced classes of package net.minecraft.src:
 //            BlockBreakable, Material
 
-public class GlassBlock extends TransparentBlock
+public class BlockGlass extends BlockTransparent
 {
 
-    public GlassBlock(String key, String namespaceId, int id, Material material)
+    public BlockGlass(String key, String namespaceId, int id, Material material)
     {
         super(key, namespaceId, id, material);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/TintedGlassBlock.java b/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
similarity index 80%
rename from src/main/java/net/minecraft/core/block/TintedGlassBlock.java
rename to src/main/java/net/minecraft/core/block/BlockGlassTinted.java
index 67ae5e4d8..977d919e2 100644
--- a/src/main/java/net/minecraft/core/block/TintedGlassBlock.java
+++ b/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
@@ -9,10 +9,10 @@ import net.minecraft.core.world.World;
 // Referenced classes of package net.minecraft.src:
 //            BlockBreakable, Material
 
-public class TintedGlassBlock extends GlassBlock
+public class BlockGlassTinted extends BlockGlass
 {
 
-    public TintedGlassBlock(String key, String namespaceID, int id)
+    public BlockGlassTinted(String key, String namespaceID, int id)
     {
         super(key, namespaceID, id, Material.glass);
     }
@@ -31,7 +31,7 @@ public class TintedGlassBlock extends GlassBlock
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity)
     {
         switch (dropCause)
         {
